﻿

Public Class Form1

    Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        Me.Text = AppTitleAndVersion()
        Load_SlotsFile()
        Load_INI()
        SetGraphType()
        SetZoom()
        EnableDisableTrackBar()
        ListView_Init()
        Timer1.Interval = 300
        Timer1.Start()
        SignalGraph1.Update(pbox_Graph)
        Refresh()
        Opacity = 1
        EventsAreEnabled = True
        SignalReaderStart()
        ' 
        SplitContainer1.Panel2MinSize = 195
    End Sub

    Private Sub Form1_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        SignalReaderStop()
        Save_INI()
    End Sub

    Private Sub Form1_LocationChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.LocationChanged
        If Not EventsAreEnabled Then Exit Sub
        LimitFormPosition(Me)
    End Sub

    Private Sub Form1_Resize(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Resize
        If Not EventsAreEnabled Then Return
        ListView1.RefreshBackground()
    End Sub

    ' ===================================================================
    '  TIMER
    ' ===================================================================
    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick
        ScanNetworks()
        SignalGraph1.Update(pbox_Graph)
        ShowNetworksData()
        UpdateSlots()
    End Sub

    ' =================================================================================================
    '  CONTROLS
    ' =================================================================================================
    Private Sub tkbar_Zoom_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tkbar_Zoom.ValueChanged
        If Not EventsAreEnabled Then Return
        SetZoom()
        Save_INI()
    End Sub

    Private Sub SetZoom()
        SignalGraph1.xScale = tkbar_Zoom.Maximum - tkbar_Zoom.Value + 1
    End Sub

    Private Sub tkbar_Zoom_MouseClick(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles tkbar_Zoom.MouseClick
        If Not EventsAreEnabled Then Return
        'ListView1.Select()
        pbox_Graph.Select()
    End Sub

    Friend ViewMode As String
    Private Sub btm_ChangeMode_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_ChangeMode.Click
        If ViewMode = "Channels" Then
            ViewMode = "Graphs"
        Else
            ViewMode = "Channels"
        End If
        EnableDisableTrackBar()
        Save_INI()
    End Sub

    Private Sub EnableDisableTrackBar()
        If ViewMode = "Channels" Then
            tkbar_Zoom.Enabled = False
        Else
            tkbar_Zoom.Enabled = True
        End If
    End Sub

    Private Sub btn_EditSlots_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_EditSlots.Click
        Me.Opacity = 0.7
        ProcessStartAndWait(Application.StartupPath & "\OutputSlots.txt")
        Load_SlotsFile()
        Me.Opacity = 1
    End Sub

    Private Sub rb_Signal_CheckedChanged(ByVal sender As System.Object, _
                                     ByVal e As System.EventArgs) Handles rb_Quality.CheckedChanged, _
                                                                          rb_Signal.CheckedChanged, _
                                                                          rb_Detect.CheckedChanged, _
                                                                          rb_QualityAndDetect.CheckedChanged
        If Not EventsAreEnabled Then Return
        SetGraphType()
        'ListView1.Select()
        pbox_Graph.Select()
        Save_INI()
    End Sub

    Private Sub SetGraphType()
        If rb_Quality.Checked Then SignalGraph1.GraphType = GraphTypes.Quality
        If rb_Signal.Checked Then SignalGraph1.GraphType = GraphTypes.Signal
        If rb_Detect.Checked Then SignalGraph1.GraphType = GraphTypes.Detections
        If rb_QualityAndDetect.Checked Then SignalGraph1.GraphType = GraphTypes.QualityAndDetections
    End Sub

    Private Sub pbox_Graph_MouseClick(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles pbox_Graph.MouseClick
        If e.Button = Windows.Forms.MouseButtons.Left Then
            SignalGraph1.SelectNet(e.X, e.Y)
        End If
    End Sub

    Private Sub ListView1_GotFocus(ByVal sender As Object, ByVal e As System.EventArgs) Handles ListView1.GotFocus
        ' --------------------------- stop system to set focus to the ListView
        pbox_Graph.Select()
    End Sub

    Private Sub ListView1_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ListView1.SelectedIndexChanged
        ' -------------------------------------------------------------------- 
        SetSelectGraph_FromSelectedListIndex()
        ' -------------------------------------------------------------------- stop system to change colors 
        ListView1.HideSelection = True
        ' -------------------------------------------------------------------- and set the preferred colors
        For n As Int32 = 0 To ListView1.Items.Count - 1
            If ListView1.Items.Item(n).Selected = False Then
                ListView1.Items.Item(n).BackColor = Drawing.Color.White
                ListView1.Items.Item(n).ForeColor = Drawing.Color.Black
            Else
                ' ------------------------------------------------------------ blue white
                'ListView1.Items.Item(n).BackColor = Drawing.Color.DodgerBlue
                'ListView1.Items.Item(n).ForeColor = Drawing.Color.White
                ' ------------------------------------------------------------ black yellow
                ListView1.Items.Item(n).BackColor = Drawing.Color.Yellow
                ListView1.Items.Item(n).ForeColor = Drawing.Color.Black
            End If
        Next
    End Sub

    Private Sub ListView1_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles ListView1.Click
        SetSelectGraph_FromSelectedListIndex()
    End Sub

    Private Sub ListView1_ItemChecked(ByVal sender As Object, ByVal e As System.Windows.Forms.ItemCheckedEventArgs) Handles ListView1.ItemChecked
        If Not EventsAreEnabled Then Return
        Dim NetIndex As Int32 = FindNetIndexFromMAC(e.Item.SubItems(13).Text)
        NetworkDataArray(NetIndex).Checked = e.Item.Checked
    End Sub


    ' ===================================================================================
    '  LIST VIEW INIT
    ' ===================================================================================
    Private Sub ListView_Init()
        With ListView1

            '.OwnerDraw = True
            .GridLines = True
            .FullRowSelect = True
            .LabelEdit = False
            '
            .View = View.Details
            .HideSelection = False
            .AllowColumnReorder = False
            .CheckBoxes = True
            .Sorting = SortOrder.None
            .HeaderStyle = ColumnHeaderStyle.Clickable
            '.HeaderStyle = ColumnHeaderStyle.Nonclickable
            .BringToFront()
            .MultiSelect = False
            '
            ' ----------------------------------------------------------------- column headers
            '.Header_BackColor1 = Color.FromArgb(255, 255, 200)
            '.Header_BackColor2 = Color.FromArgb(200, 200, 200)
            .Header_ForeColor = Color.FromArgb(20, 20, 20)
            .Header_ShadowColor = Color.FromArgb(255, 255, 200)
            .Header_Font = New Font("Microsoft Sans Serif", 10, FontStyle.Regular)
            '
            ' -----------------------------------------------------------------
            .Header_TextVerticalPosition = 1

            ' working only with OwnerDrawn
            '.Header_TextAlignments = New StringAlignment() {StringAlignment.Center, _
            '                                                StringAlignment.Center, _
            '                                                StringAlignment.Center, _
            '                                                StringAlignment.Center, _
            '                                                StringAlignment.Center, _
            '                                                StringAlignment.Center, _
            '                                                StringAlignment.Center, _
            '                                                StringAlignment.Center, _
            '                                                StringAlignment.Center, _
            '                                                StringAlignment.Center, _
            '                                                StringAlignment.Center, _
            '                                                StringAlignment.Center, _
            '                                                StringAlignment.Center, _
            '                                                StringAlignment.Center, _
            '                                                StringAlignment.Center, _
            '                                                StringAlignment.Center, _
            '                                                StringAlignment.Center, _
            '                                                StringAlignment.Near}
            .Clear()
            .Columns.Add("", 10, HorizontalAlignment.Left)
            .Columns.Add("SSID", 160, HorizontalAlignment.Left)
            .Columns.Add("RSSI", 40, HorizontalAlignment.Center)
            .Columns.Add("Quality", 70, HorizontalAlignment.Center)
            .Columns.Add("Detections", 80, HorizontalAlignment.Center)
            .Columns.Add("Channel", 60, HorizontalAlignment.Left)
            .Columns.Add("Max Rate", 70, HorizontalAlignment.Left)
            .Columns.Add("PHY Type", 80, HorizontalAlignment.Left)
            .Columns.Add("Security", 70, HorizontalAlignment.Left)
            .Columns.Add("Cypher", 60, HorizontalAlignment.Left)
            .Columns.Add("BSS Type", 80, HorizontalAlignment.Left)
            .Columns.Add("First Seen", 80, HorizontalAlignment.Left)
            .Columns.Add("Last Seen", 80, HorizontalAlignment.Left)
            .Columns.Add("MAC Address", 110, HorizontalAlignment.Left)
            .Columns.Add("Vendor", 120, HorizontalAlignment.Left)
            .Columns.Add("Router Brand", 120, HorizontalAlignment.Left)
            .Columns.Add("Router Model", 120, HorizontalAlignment.Left)
            .Columns.Add("Router Name", 120, HorizontalAlignment.Left)
        End With

        ResizeColumnsAndRefresh(ListView1)

        CreateStateImageList()
    End Sub


    Private ImageList1 As ImageList = New ImageList

    Private Sub CreateStateImageList()
        SignalGraph1.InitGraphColors()
        ImageList1.Images.Clear()
        ImageList1.ImageSize = New Size(15, 15)
        For i As Int32 = 0 To SignalGraph1.NumGraphColors - 1
            Dim bmp As Bitmap
            Dim g As Graphics
            bmp = New Bitmap(15, 15, Imaging.PixelFormat.Format24bppRgb)
            g = Graphics.FromImage(bmp)
            g.Clear(Color.White)
            g.DrawRectangle(Pens.Black, 2, 1, 10, 12)
            g.FillRectangle(New SolidBrush(SignalGraph1.GraphColors(i)), 2, 1, 10, 12)
            ImageList1.Images.Add(bmp)
        Next
        ListView1.SmallImageList = ImageList1
    End Sub


    ' =================================================================================================
    '  NETWORK DATA to ListView
    ' =================================================================================================

    Private Sub ShowNetworksData()
        If Not NewData Then Return
        NewData = False
        Dim OldSelectedLineMac As String = ""
        ' --------------------------------------------------------------- IF the network number is changed
        If ListView1.Items.Count <> NetworkDataArray.Length Then
            If ListView1.SelectedIndices.Count > 0 Then
                OldSelectedLineMac = ListView1.Items(ListView1.SelectedIndices(0)).SubItems(13).Text
            End If
            ' ----------------------------------------------------------- clear and repopulate the List
            ListView1.Items.Clear()
            For i As Int32 = 0 To NetworkDataArray.Length - 1
                EventsAreEnabled = False
                ListView1.Items.Add("")
                EventsAreEnabled = True
                For j As Int32 = 1 To 17
                    ListView1.Items(i).SubItems.Add("")
                Next
            Next
        End If

        ' ------------------------------------------------------------ update networks data
        For i As Int32 = 0 To NetworkDataArray.Length - 1
            '
            Dim SortedIndex As Int32 = GetSortedIndex(i)
            '
            With NetworkDataArray(i)
                UpdateListViewItem(SortedIndex, 1, .SSID)
                UpdateListViewItem(SortedIndex, 2, .RSSI.ToString("0") + " dB")
                UpdateListViewItem(SortedIndex, 3, .Quality.ToString("0") + " %")
                UpdateListViewItem(SortedIndex, 4, .DetectionPercentual.ToString("0") + " %")
                UpdateListViewItem(SortedIndex, 5, .Channel)
                UpdateListViewItem(SortedIndex, 6, .MaxRate)
                UpdateListViewItem(SortedIndex, 7, .PhyType)
                UpdateListViewItem(SortedIndex, 8, .Security)
                UpdateListViewItem(SortedIndex, 9, .Cypher)
                UpdateListViewItem(SortedIndex, 10, .BssType)
                UpdateListViewItem(SortedIndex, 11, .FirstDetection.ToString("HH:mm:ss"))
                UpdateListViewItem(SortedIndex, 12, .LastDetection.ToString("HH:mm:ss"))
                UpdateListViewItem(SortedIndex, 13, .MAC_Address)
                UpdateListViewItem(SortedIndex, 14, .Vendor)
                UpdateListViewItem(SortedIndex, 15, .RouterBrand)
                UpdateListViewItem(SortedIndex, 16, .RouterModel)
                UpdateListViewItem(SortedIndex, 17, .RouterName)
                ListView1.Items(SortedIndex).Checked = .Checked
                ListView1.Items(SortedIndex).ImageIndex = i Mod SignalGraph1.NumGraphColors
            End With
        Next

        If OldSelectedLineMac <> "" Then
            SelectListLineFromMAC(OldSelectedLineMac)
        End If

        ResizeColumnsAndRefresh(ListView1)
    End Sub

    Private Sub UpdateListViewItem(ByVal ItemIndex As Int32, ByVal Subitem As Int32, ByVal s As String)
        With ListView1.Items(ItemIndex).SubItems(Subitem)
            If s <> .Text Then
                .Text = s
            End If
        End With
    End Sub

    Private Sub ResizeColumnsAndRefresh(ByRef lvff As ListViewFlickerFree)
        ' ------------------------------------------------------------ Save old sizes
        Dim oldSizes(lvff.Columns.Count - 1) As Int32
        For i As Int32 = 0 To lvff.Columns.Count - 1
            oldSizes(i) = lvff.Columns(i).Width
        Next
        ' ------------------------------------------------------------ Resize columns
        lvff.AutoResizeColumns(ColumnHeaderAutoResizeStyle.HeaderSize)
        ' ------------------------------------------------------------ Compare new sizes with old sizes
        Dim RefreshNeeded As Boolean = False
        For i As Int32 = 0 To lvff.Columns.Count - 1
            If oldSizes(i) <> lvff.Columns(i).Width Then
                RefreshNeeded = True
            End If
        Next
        ' ------------------------------------------------------------ Refresh only if columns sizes are changed 
        If RefreshNeeded Then
            lvff.RefreshBackground()
        End If
    End Sub

    Private Sub UpdateSlots()
        For Each o As OutputSlotStructure In OutputSlots
            Dim net As Int32 = FindNetIndexFromSSID(o.SSID)
            If net >= 0 Then
                Dim v As Single = SignalGraph1.SelectData(NetworkDataArray(net))
                Slots.WriteSlot(o.Slot, v * 10)
            Else
                Slots.WriteSlot(o.Slot, 0)
            End If
        Next
    End Sub


    ' ============================================================================
    '  SORT COLUMNS 
    ' ============================================================================
    Private m_SortingColumn As ColumnHeader

    Private Sub ListView1_ColumnClick(ByVal sender As System.Object, _
                                     ByVal e As System.Windows.Forms.ColumnClickEventArgs) _
                                     Handles ListView1.ColumnClick

        sort_columnn_index = e.Column

        ' ---------------------------------------------------- get the new sorting column
        Dim newSortingColumn As ColumnHeader = ListView1.Columns(sort_columnn_index)

        ' ---------------------------------------------------- figure out the new sorting order

        If m_SortingColumn Is Nothing Then
            ' ------------------------------------------------ new column - sort ascending
            sort_order = SortOrder.Ascending
        Else
            ' ------------------------------------------------ if this is the same column
            If newSortingColumn.Equals(m_SortingColumn) Then
                ' -------------------------------------------- then switch the sort order
                If m_SortingColumn.Text.StartsWith("> ") Then
                    sort_order = SortOrder.Descending
                Else
                    sort_order = SortOrder.Ascending
                End If
            Else
                ' -------------------------------------------- else - sort ascending
                sort_order = SortOrder.Ascending
            End If
            ' ------------------------------------------------ remove the old sort indicator
            m_SortingColumn.Text = m_SortingColumn.Text.Substring(2)
        End If

        ' ---------------------------------------------------- display the new sort order
        m_SortingColumn = newSortingColumn
        If sort_order = SortOrder.Ascending Then
            m_SortingColumn.Text = "> " & m_SortingColumn.Text
        Else
            m_SortingColumn.Text = "< " & m_SortingColumn.Text
        End If

        ' ----------------------------------------------------
        SortNetworks()
        NewData = True
        ShowNetworksData()
        'ListView1.Refresh()

        'SetSelectGraph_FromSelectedListIndex()
        SetSelectListItem_FromSelectedGraph()

    End Sub

    ' ============================================================================
    '  Select list and graph items
    ' ============================================================================
    Friend Sub SelectListLineFromMAC(ByVal mac As String)
        Dim LineIndex As Int32 = FindListLineIndexFromMAC(mac)
        ListView1.Items(LineIndex).Selected = True
    End Sub

    Private Sub SetSelectGraph_FromSelectedListIndex()
        If ListView1.SelectedIndices.Count = 0 Then
            SignalGraph1.SelectedGraph = -1
        Else
            Dim mac As String = ListView1.Items(ListView1.SelectedIndices(0)).SubItems(13).Text
            Dim NetIndex As Int32 = FindNetIndexFromMAC(mac)
            SignalGraph1.SelectedGraph = NetIndex
        End If
    End Sub

    Private Sub SetSelectListItem_FromSelectedGraph()
        Dim oldselected As Int32 = SignalGraph1.SelectedGraph
        ListView1.SelectedIndices.Clear()
        If oldselected >= 0 Then
            Dim mac As String = NetworkDataArray(oldselected).MAC_Address
            Dim index As Int32 = FindListLineIndexFromMAC(mac)
            If index >= 0 Then ListView1.Items(index).Selected = True
        End If
    End Sub

    Friend Function FindListLineIndexFromMAC(ByVal mac As String) As Int32
        For i As Int32 = 0 To ListView1.Items.Count - 1
            If mac = ListView1.Items(i).SubItems(13).Text Then
                Return i
            End If
        Next
        Return -1
    End Function

End Class

