﻿Module Module_Networks

    Friend NewData As Boolean

    Private wlclient As WlanClient = New WlanClient()

    Friend Sub ScanNetworks()
        ' ----------------------------------------------------------------- update networks data
        If wlclient.Interfaces IsNot Nothing Then

            For i As Int32 = 0 To NetworkDataArray.Length - 1
                With NetworkDataArray(i)
                    If NetworkDataArray(i).SSID.StartsWith("Fake") Then Continue For

                    ' ----------------------------------------------------- update detection percentual
                    If Now.Subtract(.LastDetection).TotalMilliseconds < 1000 Then
                        .DetectionCount += 10
                    Else
                        .DetectionCount -= 10
                    End If
                    If .DetectionCount < 0 Then .DetectionCount = 0
                    If .DetectionCount > 100 Then .DetectionCount = 100
                    .DetectionPercentual += (.DetectionCount - .DetectionPercentual) * 0.05F
                End With
            Next

            For Each WLI As WlanInterface In wlclient.Interfaces

                Dim wlanBssEntries() As Wlan.WlanBssEntryN = CType(WLI.GetNetworkBssList, Wlan.WlanBssEntryN())

                For Each WLBE As Wlan.WlanBssEntryN In wlanBssEntries

                    Dim SSID As String = GetStringForSSID(WLBE.BaseEntry.dot11Ssid)
                    If SSID = "" Then Continue For
                    Dim i As Int32 = GetNetworkDataIndex(SSID)
                    With NetworkDataArray(i)
                        If .MAC_Address = "" Then
                            .RSSI = WLBE.BaseEntry.rssi
                            .Quality = WLBE.BaseEntry.linkQuality
                            .MAC_Address = ByteArrayToMacAddress(WLBE.BaseEntry.dot11Bssid)
                            .Vendor = GetVendorFromFileOui(.MAC_Address)
                            Dim VendorInfo As IeParser.VendorInfo = IeParser.ParseVendorInfo(WLBE.IEs)
                            .RouterBrand = VendorInfo.Brand
                            .RouterModel = VendorInfo.Model
                            .RouterName = VendorInfo.Name
                        Else
                            ' ------------------------------------------------------------ RSSI = QUALITY
                            '.RSSI += ((WLBE.BaseEntry.rssi * 2 + 100) - .RSSI) * 0.3F
                            '.Quality += (WLBE.BaseEntry.linkQuality - .Quality) * 0.3F
                            ' ------------------------------------------------------------ Normal with smooting
                            .RSSI += (WLBE.BaseEntry.rssi - .RSSI) * 0.2F
                            .Quality += (WLBE.BaseEntry.linkQuality - .Quality) * 0.2F
                            ' ------------------------------------------------------------ Without smooting
                            '.RSSI = WLBE.BaseEntry.rssi
                            '.Quality = WLBE.BaseEntry.linkQuality
                        End If

                        .PhyType = PHY_ToString(WLBE.BaseEntry.dot11BssPhyType)
                        .BssType = WLBE.BaseEntry.dot11BssType.ToString
                        .LastDetection = Now
                        NewData = True

                        Dim ACsettings As IeParser.TypeACSettings = IeParser.ParseAC(WLBE.IEs)
                        Dim Nsettings As IeParser.TypeNSettings = IeParser.Parse(WLBE.IEs)

                        If ACsettings IsNot Nothing AndAlso _
                           ACsettings.Capabilities IsNot Nothing AndAlso _
                           ACsettings.Operations IsNot Nothing Then
                            ' -------------------------------------------------------------------------- AC
                            'Dim ShortGi160MHz As Boolean = ACsettings.Capabilities.ShortGi160MHz
                            'Dim ShortGi80MHz As Boolean = ACsettings.Capabilities.ShortGi80MHz
                            Dim MaxReceiveRate As UShort = ACsettings.Capabilities.MaxReceiveRate
                            Dim MaxTransmitRate As UShort = ACsettings.Capabilities.MaxTransmitRate
                            Dim Supports160Mhz As Boolean = ACsettings.Capabilities.Supports160Mhz
                            Dim Supports80Plus80Mhz As Boolean = ACsettings.Capabilities.Supports80Plus80Mhz

                            ' NOT WORKING - ALWAYS ZERO
                            '.MaxRate = Math.Max(MaxReceiveRate, MaxTransmitRate).ToString + " Mbps"
                            ' 
                            Dim MaxRate As Int32 = 200
                            ' TODO - AC Channel and MaxRate
                            'If Supports80Plus80Mhz Then MaxRate = 400
                            'If Supports160Mhz Then MaxRate = 866

                            Dim PrimaryCh As UInt32 = ACsettings.PrimaryChannel
                            Dim SecondaryChLower As Boolean = ACsettings.SecondaryChannelLower
                            Dim SecondaryChannel As UInt32 = CUInt(PrimaryCh + If(SecondaryChLower, -4, 4))
                            '
                            Select Case ACsettings.Operations.ChannelWidth
                                Case IeParser.TypeACSettings.VHTOperations.VHTChannelWidth.Eighty
                                    ' TODO - AC Channel and MaxRate
                                    .Channel = PrimaryCh.ToString
                                    'MaxRate = ???
                                Case IeParser.TypeACSettings.VHTOperations.VHTChannelWidth.EightyPlusEighty
                                    ' TODO - AC Channel and MaxRate
                                    .Channel = PrimaryCh.ToString + " + " + SecondaryChannel.ToString
                                    MaxRate *= 2
                                Case IeParser.TypeACSettings.VHTOperations.VHTChannelWidth.OneSixty
                                    ' TODO - AC Channel and MaxRate
                                    .Channel = PrimaryCh.ToString
                                    'MaxRate = ???
                                Case IeParser.TypeACSettings.VHTOperations.VHTChannelWidth.TwentyOrForty
                                    ' TODO - AC Channel and MaxRate
                                    .Channel = PrimaryCh.ToString
                                    'MaxRate = ???
                            End Select
                            .MaxRate = MaxRate.ToString + " Mbps"

                        ElseIf Nsettings IsNot Nothing Then
                            ' -------------------------------------------------------------------------- N
                            'Dim ShortGi20MHz As Boolean = Nsettings.ShortGi20MHz
                            'Dim ShortGi40MHz As Boolean = Nsettings.ShortGi40MHz
                            Dim PrimaryCh As UInt32 = Nsettings.PrimaryChannel
                            Dim Is40Mhz As Boolean = Nsettings.Is40Mhz
                            Dim SecondaryChLower As Boolean = Nsettings.SecondaryChannelLower
                            Dim MaxRate As Single = FindMaxRate(Nsettings.Rates)

                            If Is40Mhz Then
                                Dim SecondaryChannel As UInt32 = CUInt(PrimaryCh + If(SecondaryChLower, -4, 4))
                                .Channel = PrimaryCh.ToString + " + " + SecondaryChannel.ToString
                                MaxRate *= 2
                                If MaxRate < 0 Then MaxRate = 150
                            Else
                                .Channel = PrimaryCh.ToString
                                If MaxRate < 0 Then MaxRate = 65
                            End If
                            .MaxRate = MaxRate.ToString + " Mbps"

                        Else
                            ' -------------------------------------------------------------------------- B & G
                            Dim CenterFreq As UInt32 = WLBE.BaseEntry.chCenterFrequency
                            Dim Channel As Int32 = CenterFrequencyToChannel(CenterFreq)
                            .Channel = Channel.ToString
                            .MaxRate = FindMaxRate(WLBE.BaseEntry.wlanRateSet.Rates)

                        End If

                    End With
                Next

                ' -------------------------------------------------------------------------- add Security and Cipher
                Dim WlanAvailableNetworks As IEnumerable(Of Wlan.WlanAvailableNetwork)
                WlanAvailableNetworks = WLI.GetAvailableNetworkList(Wlan.WlanGetAvailableNetworkFlags.IncludeAllAdhocProfiles)
                For Each AVN As Wlan.WlanAvailableNetwork In WlanAvailableNetworks
                    Dim SSID As String = GetStringForSSID(AVN.dot11Ssid)
                    If SSID = "" Then Continue For
                    Dim i As Int32 = GetNetworkDataIndex(SSID)
                    With NetworkDataArray(i)
                        .Security = AVN.dot11DefaultAuthAlgorithm.ToString
                        .Cypher = AVN.dot11DefaultCipherAlgorithm.ToString
                        '.SecurityEnabled = AVN.securityEnabled
                        '.Connectable = AVN.networkConnectable
                    End With
                Next

                WLI.Scan()
            Next
        End If

        ' ------------------------------------------------------- Add fake networks with keys SHIFT + CTRL
        If Debugger.IsAttached Then
            If My.Computer.Keyboard.CtrlKeyDown And _
               (My.Computer.Keyboard.ShiftKeyDown Or My.Computer.Keyboard.AltKeyDown) Then
                Randomize()
                Dim SSID As String
                Dim i As Int32
                If NetworkDataArray.Length < 14 Then
                    If My.Computer.Keyboard.AltKeyDown Then
                        SSID = GetSequentialNetName()
                    Else
                        SSID = GetFakeNetName()
                    End If
                    i = GetNetworkDataIndex(SSID)
                    With NetworkDataArray(i)
                        .RSSI = -CInt(Rnd() * 50) - 50
                        .Quality = CInt(Rnd() * 90) + 10
                        .DetectionPercentual = Rnd() * 10
                        .LastDetection = Now
                        If .PhyType = "" Then .PhyType = GetRandomPhy()
                        If .MaxRate = "" Then .MaxRate = GetRateFromPhy(.PhyType)
                        If .Channel = "" Then .Channel = GetChannelFromPhy(.PhyType)
                        If .Security = "" Then .Security = GetRandomSecurity()
                        If .Cypher = "" Then .Cypher = GetRandomCypher()
                        If .BssType = "" Then .BssType = GetRandomBssType()
                        If .MAC_Address = "" Then .MAC_Address = GetRandomMacFromOui()
                        If .Vendor = "" Then .Vendor = GetVendorFromFileOui(.MAC_Address)
                    End With
                Else
                    i = CInt(Rnd() * 9)
                    With NetworkDataArray(i)
                        .RSSI = .RSSI + CInt((Rnd() - 0.5) * 3)
                        .Quality = .RSSI * 2 + 200
                        If .Quality > 100 Then .Quality = 100
                        If .Quality < 0 Then .Quality = 0
                        .DetectionPercentual += Rnd() + 0.2F
                        If .DetectionPercentual > 100 Then .DetectionPercentual = 100
                        .LastDetection = Now
                    End With
                End If
                NewData = True
            End If
        End If

    End Sub

    ' =============================================================================
    '  Random MAC, SSID etc...
    ' =============================================================================
    Private Function GetRandomMac() As String
        Dim mac As String = ""
        For i As Byte = 1 To 6
            mac += (CInt(Rnd() * 255)).ToString("x2").ToUpper + "-"
        Next
        Return Strings.Left(mac, 17)
    End Function

    Private Function GetRandomMacFromOui() As String
        Dim fname As String
        fname = Application.StartupPath + "\VendorsFiles\" + "oui.txt"
        If My.Computer.FileSystem.FileExists(fname) Then
            Dim sa As String() = IO.File.ReadAllLines(fname)
            Do
                Dim i As Int32 = CInt(Rnd() * (sa.Length - 1))
                Dim s As String = Left(sa(i), 8)
                If Mid(s, 3, 1) = "-" Then
                    Return s + "-" + Left(GetRandomMac, 8)
                End If
            Loop
        End If
        Return GetRandomMac()
    End Function

    Private Function GetSequentialNetName() As String
        Static i As Int32 = 0
        Dim s() As String = {"MyHomeNetwork", "Area 51", "FBI_AP1", "Do not touch", _
                            "SecureAP", "NotForYou", "TheBeerStore", "hack_me", _
                            "Access Denied", "Excalibur", "Not Found", "Your neighbor"}
        Return s(CInt(Rnd() * (s.Length - 1)))
        i = (i + 1) Mod s.Length
    End Function
    Private Function GetFakeNetName() As String
        Return "Fake network " + CInt(Rnd() * 100).ToString
    End Function

    Private Function GetRandomPhy() As String
        Dim s() As String = {"802.11b", "802.11g", "802.11g", "802.11g", "802.11g", "802.11n", "802.11n", "802.11n"}
        Return s(CInt(Rnd() * (s.Length - 1)))
    End Function

    Private Function GetRateFromPhy(ByVal PhyType As String) As String
        Select Case PhyType
            Case "802.11b" : Return "11 Mbps"
            Case "802.11g" : Return "54 Mbps"
            Case "802.11n"
                Dim s() As String = {"144 Mbps", "300 Mbps", "450 Mbps", "600 Mbps"}
                Return s(CInt(Rnd() * (s.Length - 1)))
            Case Else
                Return "1.2 Mbps"
        End Select
    End Function

    Private Function GetChannelFromPhy(ByVal PhyType As String) As String
        Dim n As Int32 = CInt(1 + Rnd() * 12)
        If PhyType = "802.11n" Then
            If n > 10 Then n -= 10
            Return n.ToString + " + " + (n + 4).ToString
        Else
            Return n.ToString()
        End If
    End Function

    Private Function GetRandomSecurity() As String
        Dim s() As String = {"RSNA_PSK", "RSNA_PSK", "WPA_PSK", "RSNA"}
        Return s(CInt(Rnd() * (s.Length - 1)))
    End Function

    Private Function GetRandomCypher() As String
        Dim s() As String = {"CCMP", "CCMP", "CCMP", "TKIP", "TKIP"}
        Return s(CInt(Rnd() * (s.Length - 1)))
    End Function

    Private Function GetRandomBssType() As String
        Dim s() As String = {"Infrastructure"}
        Return s(CInt(Rnd() * (s.Length - 1)))
    End Function

    ' =============================================================================
    '  Network data array
    ' =============================================================================
    Friend NetworkDataArray(-1) As NetworkData

    Friend Structure NetworkData
        Dim SortIndex As Int32
        Dim Checked As Boolean
        Dim SSID As String
        Dim RSSI As Single
        Dim Quality As Single
        Dim DetectionCount As Int32
        Dim DetectionPercentual As Single
        Dim Channel As String
        Dim MaxRate As String
        Dim PhyType As String
        Dim Security As String
        Dim Cypher As String
        Dim BssType As String
        Dim FirstDetection As DateTime
        Dim LastDetection As DateTime
        Dim MAC_Address As String
        Dim Vendor As String
        Dim RouterBrand As String
        Dim RouterModel As String
        Dim RouterName As String

        'Dim Connectable As Boolean                  ' unused
        'Dim SecurityEnabled As Boolean              ' unused
        'Dim WPS_Support As Boolean                  ' not found
    End Structure


    Private Function GetNetworkDataIndex(ByVal SSID As String) As Int32
        ' -------------------------------------------------------- if exists return the index
        For i As Int32 = 0 To NetworkDataArray.Length - 1
            If SSID = NetworkDataArray(i).SSID Then Return i
        Next
        ' -------------------------------------------------------- else add the element at the and of the array
        ReDim Preserve NetworkDataArray(NetworkDataArray.Length)
        NetworkDataArray(NetworkDataArray.Length - 1).SSID = SSID
        NetworkDataArray(NetworkDataArray.Length - 1).FirstDetection = Now
        NetworkDataArray(NetworkDataArray.Length - 1).Checked = True
        ' -------------------------------------------------------- sort the "SortIndex" field
        SortNetworks()
        ' -------------------------------------------------------- and return the index of the last element
        Return NetworkDataArray.Length - 1
    End Function


    ' =============================================================================
    '   SORTED to UNSORTED indexes
    ' =============================================================================
    Friend Function GetSortedIndex(ByVal index As Int32) As Int32
        Return NetworkDataArray(index).SortIndex
    End Function

    ' =============================================================================
    '   SORT 
    ' =============================================================================
    Friend sort_order As System.Windows.Forms.SortOrder = SortOrder.Ascending
    Friend sort_columnn_index As Int32 = 0

    Private Structure SortEntry
        Dim index As Int32
        Dim str As String
    End Structure

    Friend Sub SortNetworks()
        SortNetworks(sort_columnn_index, sort_order)
        Form1.ListView1.Refresh()
    End Sub

    Private Sub SortNetworks(ByVal column As Int32, ByVal sortorder As System.Windows.Forms.SortOrder)
        If column = 0 Then
            SortNetworksByDetectOrder(sortorder)
        Else
            SortNetworksByColumn(column, sortorder)
        End If
    End Sub

    Private Sub SortNetworksByDetectOrder(ByVal sortorder As System.Windows.Forms.SortOrder)
        Dim len As Int32 = NetworkDataArray.Length
        If len = 0 Then Return
        For i As Int32 = 0 To len - 1
            If sortorder = Windows.Forms.SortOrder.Ascending Then
                NetworkDataArray(i).SortIndex = i
            Else
                NetworkDataArray(i).SortIndex = NetworkDataArray.Length - 1 - i
            End If
        Next
    End Sub

    Private Sub SortNetworksByColumn(ByVal column As Int32, ByVal sortorder As System.Windows.Forms.SortOrder)
        Dim len As Int32 = NetworkDataArray.Length
        If len = 0 Then Return
        ' ------------------------------------------------------------- prepare the sort array
        Dim SortArray(len - 1) As SortEntry
        For i As Int32 = 0 To len - 1
            SortArray(i).index = i
            Select Case column
                Case 1 : SortArray(i).str = NetworkDataArray(i).SSID
                Case 2 : SortArray(i).str = NetworkDataArray(i).RSSI.ToString
                Case 3 : SortArray(i).str = NetworkDataArray(i).Quality.ToString
                Case 4 : SortArray(i).str = NetworkDataArray(i).DetectionPercentual.ToString
                Case 5 : SortArray(i).str = NetworkDataArray(i).Channel
                Case 6 : SortArray(i).str = NetworkDataArray(i).MaxRate
                Case 7 : SortArray(i).str = NetworkDataArray(i).PhyType
                Case 8 : SortArray(i).str = NetworkDataArray(i).Security
                Case 9 : SortArray(i).str = NetworkDataArray(i).Cypher
                Case 10 : SortArray(i).str = NetworkDataArray(i).BssType
                Case 11 : SortArray(i).str = NetworkDataArray(i).FirstDetection.ToString("HH:mm:ss")
                Case 12 : SortArray(i).str = NetworkDataArray(i).LastDetection.ToString("HH:mm:ss")
                Case 13 : SortArray(i).str = NetworkDataArray(i).MAC_Address
                Case 14 : SortArray(i).str = NetworkDataArray(i).Vendor
                Case 15 : SortArray(i).str = NetworkDataArray(i).RouterBrand
                Case 16 : SortArray(i).str = NetworkDataArray(i).RouterModel
                Case 17 : SortArray(i).str = NetworkDataArray(i).RouterName
            End Select
        Next
        ' ------------------------------------------------------------- sort the array
        Array.Sort(SortArray, AddressOf CompareSortEntry)
        ' ------------------------------------------------------------- copy sorted indexes
        For i As Int32 = 0 To len - 1
            If sortorder = Windows.Forms.SortOrder.Ascending Then
                NetworkDataArray(SortArray(i).index).SortIndex = i
            Else
                NetworkDataArray(SortArray(i).index).SortIndex = NetworkDataArray.Length - 1 - i
            End If
        Next

        ' -------------------------------------------------------------- Debug SortArray
        'Debug.Print("--------------------------------")
        'For i As Int32 = 0 To len - 1
        '    With SortArray(i)
        '        Debug.Print(.str.PadRight(20) + "    " + .index.ToString)
        '    End With
        'Next
        'Debug.Print("--------------------------------" + vbCrLf)

        ' -------------------------------------------------------------- Debug NetworkDataArray
        'Debug.Print("--------------------------------")
        'For i As Int32 = 0 To len - 1
        '    With NetworkDataArray(i)
        '        Debug.Print(.SSID.PadRight(20) + "    " + .SortIndex.ToString)
        '    End With
        'Next
        'Debug.Print("--------------------------------" + vbCrLf)
    End Sub

    Private Function CompareSortEntry(ByVal s1 As SortEntry, ByVal s2 As SortEntry) As Int32
        Return CompareStrings_AlsoNumerics(s1.str, s2.str)
    End Function

    Friend Function FindNetIndexFromSSID(ByVal ssid As String) As Int32
        For i As Int32 = 0 To NetworkDataArray.Length - 1
            If ssid = NetworkDataArray(i).SSID Then
                Return i
            End If
        Next
        Return -1
    End Function

    Friend Function FindNetIndexFromMAC(ByVal mac As String) As Int32
        For i As Int32 = 0 To NetworkDataArray.Length - 1
            If mac = NetworkDataArray(i).MAC_Address Then
                Return i
            End If
        Next
        Return -1
    End Function

End Module
