
Imports System.ComponentModel
Imports System.Diagnostics
Imports System.Net.NetworkInformation
Imports System.Runtime.InteropServices
Imports System.Text

Public NotInheritable Class Wlan
    Private Sub New()
    End Sub
#Region "Fields"

    Public Const WlanClientVersionLonghorn As UInteger = 2
    Public Const WlanClientVersionXpSp2 As UInteger = 1

#End Region

#Region "Enumerations"

    Public Enum Dot11AuthAlgorithm As UInteger
        IEEE80211_Open = 1
        IEEE80211_SharedKey = 2
        IHV_End = &HFFFFFFFFUI
        IHV_Start = &H80000000UI
        RSNA = 6
        RSNA_PSK = 7
        WPA = 3
        WPA_None = 5
        WPA_PSK = 4
    End Enum

    Public Enum Dot11BssType
        Any = 3
        Independent = 2
        Infrastructure = 1
    End Enum

    Public Enum Dot11CipherAlgorithm As UInteger
        CCMP = 4
        IHV_End = &HFFFFFFFFUI
        IHV_Start = &H80000000UI
        None = 0
        RSN_UseGroup = &H100
        TKIP = 2
        WEP = &H101
        WEP104 = 5
        WEP40 = 1
        WPA_UseGroup = &H100
    End Enum

    <Flags()> _
    Public Enum Dot11OperationMode As UInteger
        Ap = 2
        ExtensibleStation = 4
        NetworkMonitor = &H80000000UI
        Station = 1
        Unknown = 0
    End Enum

    Public Enum Dot11PhyType As UInteger
        Any = 0
        Dsss = 2
        Erp = 6
        Fhss = 1
        Hrdsss = 5
        Ht = 7
        Vht = 8
        IhvEnd = &HFFFFFFFFUI
        IhvStart = &H80000000UI
        IrBaseband = 3
        Ofdm = 4
        Unknown = 0
    End Enum

    <Flags()> _
    Public Enum WlanAccess
        ExecuteAccess = &H20021
        ReadAccess = &H20001
        WriteAccess = &H70023
    End Enum

    Public Enum WlanAdhocNetworkState
        Formed
        Connected
    End Enum

    <Flags()> _
    Public Enum WlanConnectionFlags
        AdhocJoinOnly = 2
        EapolPassthrough = 8
        HiddenNetwork = 1
        IgnorePrivacyBit = 4
    End Enum

    Public Enum WlanConnectionMode
        Profile
        TemporaryProfile
        DiscoverySecure
        DiscoveryUnsecure
        Auto
        Invalid
    End Enum

    '
    '        public class WlanException : Exception
    '        {
    '            private readonly Wlan.WlanReasonCode reasonCode;
    '
    '            private WlanException(Wlan.WlanReasonCode reasonCode)
    '            {
    '                this.reasonCode = reasonCode;
    '            }
    '
    '            public override string Message
    '            {
    '                get
    '                {
    '                    StringBuilder stringBuffer = new StringBuilder(0x400);
    '                    if (Wlan.WlanReasonCodeToString(this.reasonCode, stringBuffer.Capacity, stringBuffer, IntPtr.Zero) == 0)
    '                    {
    '                        return stringBuffer.ToString();
    '                    }
    '                    return string.Empty;
    '                }
    '            }
    '
    '            public Wlan.WlanReasonCode ReasonCode
    '            {
    '                get
    '                {
    '                    return this.reasonCode;
    '                }
    '            }
    '        }
    '        

    <Flags()> _
    Public Enum WlanGetAvailableNetworkFlags
        IncludeAllAdhocProfiles = 1
        IncludeAllManualHiddenProfiles = 2
    End Enum

    Public Enum WlanInterfaceState
        NotReady
        Connected
        AdHocNetworkFormed
        Disconnecting
        Disconnected
        Associating
        Discovering
        Authenticating
    End Enum

    Public Enum WlanIntfOpcode
        AutoconfEnabled = 1
        BackgroundScanEnabled = 2
        BssType = 5
        ChannelNumber = 8
        CurrentConnection = 7
        CurrentOperationMode = 12
        IhvEnd = &H3FFFFFFF
        IhvStart = &H30000000
        InterfaceState = 6
        MediaStreamingMode = 3
        RadioState = 4
        Rssi = &H10000102
        SecurityEnd = &H2FFFFFFF
        SecurityStart = &H20010000
        Statistics = &H10000101
        SupportedAdhocAuthCipherPairs = 10
        SupportedCountryOrRegionStringList = 11
        SupportedInfrastructureAuthCipherPairs = 9
    End Enum

    Public Enum WlanNotificationCodeAcm
        AdhocNetworkStateChange = &H16
        AutoconfDisabled = 2
        AutoconfEnabled = 1
        BackgroundScanDisabled = 4
        BackgroundScanEnabled = 3
        BssTypeChange = 5
        ConnectionAttemptFail = 11
        ConnectionComplete = 10
        ConnectionStart = 9
        Disconnected = &H15
        Disconnecting = 20
        FilterListChange = 12
        InterfaceArrival = 13
        InterfaceRemoval = 14
        NetworkAvailable = &H13
        NetworkNotAvailable = &H12
        PowerSettingChange = 6
        ProfileChange = 15
        ProfileNameChange = &H10
        ProfilesExhausted = &H11
        ScanComplete = 7
        ScanFail = 8
    End Enum

    Public Enum WlanNotificationCodeMsm
        AdapterOperationModeChange = 14
        AdapterRemoval = 13
        Associated = 2
        Associating = 1
        Authenticating = 3
        Connected = 4
        Disassociating = 9
        Disconnected = 10
        PeerJoin = 11
        PeerLeave = 12
        RadioStateChange = 7
        RoamingEnd = 6
        RoamingStart = 5
        SignalQualityChange = 8
    End Enum

    <Flags()> _
    Public Enum WlanNotificationSource
        Acm = 8
        All = &HFFFF
        Ihv = &H40
        Msm = &H10
        None = 0
        Security = &H20
    End Enum

    Public Enum WlanOpcodeValueType
        QueryOnly
        SetByGroupPolicy
        SetByUser
        Invalid
    End Enum

    <Flags()> _
    Public Enum WlanProfileFlags
        AllUser
        GroupPolicy
        User
    End Enum

    Public Enum WlanReasonCode
        AcBase = &H20000
        AcConnectBase = &H28000
        AcEnd = &H2FFFF
        AdhocSecurityFailure = &H3800A
        AssociationFailure = &H38002
        AssociationTimeout = &H38003
        AutoSwitchSetForAdhoc = &H80010
        AutoSwitchSetForManualConnection = &H80011
        Base = &H20000
        BssTypeNotAllowed = &H28005
        BssTypeUnmatch = &H30003
        ConflictSecurity = &H8000B
        ConnectCallFail = &H28009
        DatarateUnmatch = &H30005
        DisconnectTimeout = &H3800F
        DriverDisconnected = &H3800B
        DriverOperationFailure = &H3800C
        GpDenied = &H28003
        IhvNotAvailable = &H3800D
        IhvNotResponding = &H3800E
        IhvOuiMismatch = &H80008
        IhvOuiMissing = &H80009
        IhvSecurityNotSupported = &H80007
        IhvSecurityOnexMissing = &H80012
        IhvSettingsMissing = &H8000A
        InBlockedList = &H28007
        InFailedList = &H28006
        InternalFailure = &H38010
        InvalidAdhocConnectionMode = &H8000E
        InvalidBssType = &H8000D
        InvalidPhyType = &H80005
        InvalidProfileName = &H80003
        InvalidProfileSchema = &H80001
        InvalidProfileType = &H80004
        KeyMismatch = &H2800D
        MsmBase = &H30000
        MsmConnectBase = &H38000
        MsmEnd = &H3FFFF
        MsmSecurityMissing = &H80006
        MsmsecAuthStartTimeout = &H48002
        MsmsecAuthSuccessTimeout = &H48003
        MsmsecBase = &H40000
        MsmsecCancelled = &H48011
        MsmsecCapabilityDiscovery = &H40015
        MsmsecCapabilityNetwork = &H40012
        MsmsecCapabilityNic = &H40013
        MsmsecCapabilityProfile = &H40014
        MsmsecCapabilityProfileAuth = &H4001E
        MsmsecCapabilityProfileCipher = &H4001F
        MsmsecConnectBase = &H48000
        MsmsecDowngradeDetected = &H48013
        MsmsecEnd = &H4FFFF
        MsmsecForcedFailure = &H48015
        MsmsecG1MissingGrpKey = &H4800D
        MsmsecG1MissingKeyData = &H4800C
        MsmsecKeyFormat = &H48012
        MsmsecKeyStartTimeout = &H48004
        MsmsecKeySuccessTimeout = &H48005
        MsmsecM3MissingGrpKey = &H48008
        MsmsecM3MissingIe = &H48007
        MsmsecM3MissingKeyData = &H48006
        MsmsecMax = &H4FFFF
        MsmsecMin = &H40000
        MsmsecMixedCell = &H40019
        MsmsecNicFailure = &H48010
        MsmsecNoAuthenticator = &H4800F
        MsmsecNoPairwiseKey = &H4800B
        MsmsecPeerIndicatedInsecure = &H4800E
        MsmsecPrIeMatching = &H48009
        MsmsecProfileAuthTimersInvalid = &H4001A
        MsmsecProfileDuplicateAuthCipher = &H40007
        MsmsecProfileInvalidAuthCipher = &H40009
        MsmsecProfileInvalidGkeyIntv = &H4001B
        MsmsecProfileInvalidKeyIndex = &H40001
        MsmsecProfileInvalidPmkcacheMode = &H4000C
        MsmsecProfileInvalidPmkcacheSize = &H4000D
        MsmsecProfileInvalidPmkcacheTtl = &H4000E
        MsmsecProfileInvalidPreauthMode = &H4000F
        MsmsecProfileInvalidPreauthThrottle = &H40010
        MsmsecProfileKeyLength = &H40003
        MsmsecProfileKeyUnmappedChar = &H4001D
        MsmsecProfileKeymaterialChar = &H40017
        MsmsecProfileNoAuthCipherSpecified = &H40005
        MsmsecProfileOnexDisabled = &H4000A
        MsmsecProfileOnexEnabled = &H4000B
        MsmsecProfilePassphraseChar = &H40016
        MsmsecProfilePreauthOnlyEnabled = &H40011
        MsmsecProfilePskLength = &H40004
        MsmsecProfilePskPresent = &H40002
        MsmsecProfileRawdataInvalid = &H40008
        MsmsecProfileTooManyAuthCipherSpecified = &H40006
        MsmsecProfileWrongKeytype = &H40018
        MsmsecPskMismatchSuspected = &H48014
        MsmsecSecIeMatching = &H4800A
        MsmsecSecurityUiFailure = &H48016
        MsmsecTransitionNetwork = &H4001C
        MsmsecUiRequestFailure = &H48001
        NetworkNotAvailable = &H2800B
        NetworkNotCompatible = &H20001
        NoAutoConnection = &H28001
        NonBroadcastSetForAdhoc = &H8000F
        NotVisible = &H28002
        PhyTypeUnmatch = &H30004
        PreSecurityFailure = &H38004
        ProfileBase = &H80000
        ProfileChangedOrDeleted = &H2800C
        ProfileConnectBase = &H88000
        ProfileEnd = &H8FFFF
        ProfileMissing = &H80002
        ProfileNotCompatible = &H20002
        ProfileSsidInvalid = &H80013
        RangeSize = &H10000
        RoamingFailure = &H38008
        RoamingSecurityFailure = &H38009
        ScanCallFail = &H2800A
        SecurityFailure = &H38006
        SecurityMissing = &H8000C
        SecurityTimeout = &H38007
        SsidListTooLong = &H28008
        StartSecurityFailure = &H38005
        Success = 0
        TooManySecurityAttempts = &H38012
        TooManySsid = &H80014
        UiRequestTimeout = &H38011
        Unknown = &H10001
        UnsupportedSecuritySet = &H30002
        UnsupportedSecuritySetByOs = &H30001
        UserCancelled = &H38001
        UserDenied = &H28004
        UserNotRespond = &H2800E
    End Enum

    <Flags()> _
    Private Enum WlanAvailableNetworkFlags
        Connected = 1
        HasProfile = 2
    End Enum

#End Region

#Region "Delegates"

    Public Delegate Sub WlanNotificationCallbackDelegate(ByRef notificationData As Wlan.WlanNotificationData, ByVal context As IntPtr)

#End Region

#Region "Public Methods"

    <StructLayout(LayoutKind.Sequential)> _
    Public Structure Dot11Ssid
        Public ReadOnly SSIDLength As UInteger
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=&H20)> _
        Public ReadOnly SSID As Byte()
    End Structure

    <StructLayout(LayoutKind.Sequential)> _
    Public Structure WlanAssociationAttributes
        Private ReadOnly dot11Ssid As Dot11Ssid
        Private ReadOnly dot11BssType As Dot11BssType
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=6)> _
        Private ReadOnly m_dot11Bssid As Byte()
        Private ReadOnly dot11PhyType As Dot11PhyType
        Private ReadOnly dot11PhyIndex As UInteger
        Private ReadOnly wlanSignalQuality As UInteger
        Private ReadOnly rxRate As UInteger
        Private ReadOnly txRate As UInteger

        Public ReadOnly Property Dot11Bssid() As PhysicalAddress
            Get
                Return If(m_dot11Bssid IsNot Nothing, New PhysicalAddress(m_dot11Bssid), New PhysicalAddress(New Byte() {0, 0, 0, 0, 0, 0}))
            End Get
        End Property
    End Structure

    <StructLayout(LayoutKind.Sequential, CharSet:=CharSet.Unicode)> _
    Public Structure WlanAvailableNetwork
        <MarshalAs(UnmanagedType.ByValTStr, SizeConst:=&H100)> _
        Private ReadOnly profileName As String
        Public dot11Ssid As Dot11Ssid
        Private ReadOnly dot11BssType As Dot11BssType
        Private ReadOnly numberOfBssids As UInteger
        Public ReadOnly networkConnectable As Boolean
        Private ReadOnly wlanNotConnectableReason As WlanReasonCode
        Private ReadOnly numberOfPhyTypes As UInteger
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=8)> _
        Private ReadOnly m_dot11PhyTypes As Dot11PhyType()
        Private ReadOnly morePhyTypes As Boolean
        Public ReadOnly wlanSignalQuality As UInteger
        Public ReadOnly securityEnabled As Boolean
        Public ReadOnly dot11DefaultAuthAlgorithm As Dot11AuthAlgorithm
        Public ReadOnly dot11DefaultCipherAlgorithm As Dot11CipherAlgorithm
        Private ReadOnly flags As WlanAvailableNetworkFlags
        Private ReadOnly reserved As UInteger

        Public ReadOnly Property Dot11PhyTypes() As Dot11PhyType()
            Get
                Dim destinationArray As Dot11PhyType() = New Dot11PhyType(CInt(numberOfPhyTypes - 1)) {}
                Array.Copy(m_dot11PhyTypes, destinationArray, numberOfPhyTypes)
                Return destinationArray
            End Get
        End Property
    End Structure

    <StructLayout(LayoutKind.Sequential)> _
    Public Structure WlanBssEntry
        Public dot11Ssid As Dot11Ssid
        Private ReadOnly phyId As UInteger
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=6)> _
        Public ReadOnly dot11Bssid As Byte()
        Public ReadOnly dot11BssType As Dot11BssType
        Public ReadOnly dot11BssPhyType As Dot11PhyType
        Public ReadOnly rssi As Integer
        Public ReadOnly linkQuality As UInteger
        Private ReadOnly inRegDomain As Boolean
        Private ReadOnly beaconPeriod As UShort
        Private ReadOnly timestamp As ULong
        Private ReadOnly hostTimestamp As ULong
        Private ReadOnly capabilityInformation As UShort
        Public ReadOnly chCenterFrequency As UInteger
        Public wlanRateSet As WlanRateSet
        Public ReadOnly ieOffset As UInteger
        Public ReadOnly ieSize As UInteger
    End Structure

    'Added 7-29-10 by Tyler
    Public Class WlanBssEntryN
        Public BaseEntry As WlanBssEntry
        Public NSettings As IeParser.TypeNSettings
        Public IEs As Byte()

        Public Sub New(ByVal bssEntry As WlanBssEntry)
            BaseEntry = bssEntry
        End Sub
    End Class

    <DllImport("wlanapi.dll")> _
    Public Shared Function WlanCloseHandle(<[In]()> ByVal clientHandle As IntPtr, <[In](), Out()> ByVal pReserved As IntPtr) As Integer
    End Function

    <DllImport("wlanapi.dll")> _
    Public Shared Function WlanConnect(<[In]()> ByVal clientHandle As IntPtr, <[In](), MarshalAs(UnmanagedType.LPStruct)> ByVal interfaceGuid As Guid, <[In]()> ByRef connectionParameters As WlanConnectionParameters, ByVal pReserved As IntPtr) As Integer
    End Function

    <StructLayout(LayoutKind.Sequential, CharSet:=CharSet.Unicode)> _
    Public Structure WlanConnectionAttributes
        Public ReadOnly isState As WlanInterfaceState
        Public ReadOnly wlanConnectionMode As WlanConnectionMode
        <MarshalAs(UnmanagedType.ByValTStr, SizeConst:=&H100)> _
        Private ReadOnly profileName As String
        Public ReadOnly wlanAssociationAttributes As WlanAssociationAttributes
        Private ReadOnly wlanSecurityAttributes As WlanSecurityAttributes
    End Structure

    <StructLayout(LayoutKind.Sequential, CharSet:=CharSet.Unicode)> _
    Public Structure WlanConnectionNotificationData
        Private ReadOnly wlanConnectionMode As WlanConnectionMode
        <MarshalAs(UnmanagedType.ByValTStr, SizeConst:=&H20)> _
        Public ReadOnly profileName As String
        Private ReadOnly dot11Ssid As Dot11Ssid
        Private ReadOnly dot11BssType As Dot11BssType
        Private ReadOnly securityEnabled As Boolean
        Public ReadOnly wlanReasonCode As WlanReasonCode
        <MarshalAs(UnmanagedType.ByValTStr, SizeConst:=1)> _
        Public profileXml As String
    End Structure

    <StructLayout(LayoutKind.Sequential)> _
    Public Structure WlanConnectionParameters
        Public wlanConnectionMode As WlanConnectionMode
        <MarshalAs(UnmanagedType.LPWStr)> _
        Public profile As String
        Public dot11SsidPtr As IntPtr
        Private desiredBssidListPtr As IntPtr
        Public dot11BssType As Dot11BssType
        Public flags As WlanConnectionFlags
    End Structure

    <DllImport("wlanapi.dll")> _
    Public Shared Function WlanDeleteProfile(<[In]()> ByVal clientHandle As IntPtr, <[In](), MarshalAs(UnmanagedType.LPStruct)> ByVal interfaceGuid As Guid, <[In](), MarshalAs(UnmanagedType.LPWStr)> ByVal profileName As String, ByVal reservedPtr As IntPtr) As Integer
    End Function

    <DllImport("wlanapi.dll")> _
    Public Shared Function WlanEnumInterfaces(<[In]()> ByVal clientHandle As IntPtr, <[In](), Out()> ByVal pReserved As IntPtr, ByRef ppInterfaceList As IntPtr) As Integer
    End Function

    <DllImport("wlanapi.dll")> _
    Public Shared Sub WlanFreeMemory(ByVal pMemory As IntPtr)
    End Sub

    <DllImport("wlanapi.dll")> _
    Public Shared Function WlanGetAvailableNetworkList(<[In]()> ByVal clientHandle As IntPtr, <[In](), MarshalAs(UnmanagedType.LPStruct)> ByVal interfaceGuid As Guid, <[In]()> ByVal flags As WlanGetAvailableNetworkFlags, <[In](), Out()> ByVal reservedPtr As IntPtr, ByRef availableNetworkListPtr As IntPtr) As Integer
    End Function

    <DllImport("wlanapi.dll")> _
    Public Shared Function WlanGetNetworkBssList(<[In]()> ByVal clientHandle As IntPtr, <[In](), MarshalAs(UnmanagedType.LPStruct)> ByVal interfaceGuid As Guid, <[In]()> ByVal dot11SsidInt As IntPtr, <[In]()> ByVal dot11BssType As Dot11BssType, <[In]()> ByVal securityEnabled As Boolean, ByVal reservedPtr As IntPtr, _
     ByRef wlanBssList As IntPtr) As Integer
    End Function

    <DllImport("wlanapi.dll")> _
    Public Shared Function WlanGetProfile(<[In]()> ByVal clientHandle As IntPtr, <[In](), MarshalAs(UnmanagedType.LPStruct)> ByVal interfaceGuid As Guid, <[In](), MarshalAs(UnmanagedType.LPWStr)> ByVal profileName As String, <[In]()> ByVal pReserved As IntPtr, ByRef profileXml As IntPtr, <[Optional]()> ByRef flags As WlanProfileFlags, _
     <[Optional]()> ByRef grantedAccess As WlanAccess) As Integer
    End Function

    <DllImport("wlanapi.dll")> _
    Public Shared Function WlanGetProfileList(<[In]()> ByVal clientHandle As IntPtr, <[In](), MarshalAs(UnmanagedType.LPStruct)> ByVal interfaceGuid As Guid, <[In]()> ByVal pReserved As IntPtr, ByRef profileList As IntPtr) As Integer
    End Function

    <StructLayout(LayoutKind.Sequential, CharSet:=CharSet.Unicode)> _
    Public Structure WlanInterfaceInfo
        Public interfaceGuid As Guid
        <MarshalAs(UnmanagedType.ByValTStr, SizeConst:=&H100)> _
        Public ReadOnly interfaceDescription As String
        Private ReadOnly isState As WlanInterfaceState
    End Structure

    <StructLayout(LayoutKind.Sequential)> _
    Public Structure WlanNotificationData
        Public ReadOnly notificationSource As WlanNotificationSource
        Public ReadOnly m_notificationCode As Integer
        Public interfaceGuid As Guid
        Public ReadOnly dataSize As Integer
        Public dataPtr As IntPtr

        Public ReadOnly Property NotificationCode() As Object
            Get
                If notificationSource = WlanNotificationSource.Msm Then
                    Return CType(m_notificationCode, WlanNotificationCodeMsm)
                End If
                If notificationSource = WlanNotificationSource.Acm Then
                    Return CType(m_notificationCode, WlanNotificationCodeAcm)
                End If
                Return m_notificationCode
            End Get
        End Property
    End Structure

    <DllImport("wlanapi.dll")> _
    Public Shared Function WlanOpenHandle(<[In]()> ByVal clientVersion As UInteger, <[In](), Out()> ByVal pReserved As IntPtr, ByRef negotiatedVersion As UInteger, ByRef clientHandle As IntPtr) As Integer
    End Function

    <StructLayout(LayoutKind.Sequential, CharSet:=CharSet.Unicode)> _
    Public Structure WlanProfileInfo
        <MarshalAs(UnmanagedType.ByValTStr, SizeConst:=&H100)> _
        Private ReadOnly profileName As String
        Private ReadOnly profileFlags As WlanProfileFlags
    End Structure

    <DllImport("wlanapi.dll")> _
    Public Shared Function WlanQueryInterface(<[In]()> ByVal clientHandle As IntPtr, <[In](), MarshalAs(UnmanagedType.LPStruct)> ByVal interfaceGuid As Guid, <[In]()> ByVal opCode As WlanIntfOpcode, <[In](), Out()> ByVal pReserved As IntPtr, ByRef dataSize As Integer, ByRef ppData As IntPtr, _
     ByRef wlanOpcodeValueType As WlanOpcodeValueType) As Integer
    End Function

    <StructLayout(LayoutKind.Sequential)> _
    Public Structure WlanRateSet
        Private ReadOnly rateSetLength As UInteger
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=&H7E)> _
        Private ReadOnly rateSet As UShort()

        Public ReadOnly Property Rates() As UShort()
            Get
                Dim destinationArray As UShort() = New UShort(CInt(rateSetLength - 1)) {}
                Array.Copy(rateSet, destinationArray, destinationArray.Length)
                Return destinationArray
            End Get
        End Property

        Public Function GetRateInMbps(ByVal rate As Integer) As Double
            Return ((rateSet(rate) And &H7FFF) * 0.5)
        End Function
    End Structure

    <DllImport("wlanapi.dll")> _
    Public Shared Function WlanReasonCodeToString(<[In]()> ByVal reasonCode As WlanReasonCode, <[In]()> ByVal bufferSize As Integer, <[In](), Out()> ByVal stringBuffer As StringBuilder, ByVal pReserved As IntPtr) As Integer
    End Function

    <DllImport("wlanapi.dll")> _
    Public Shared Function WlanRegisterNotification(<[In]()> ByVal clientHandle As IntPtr, <[In]()> ByVal notifSource As WlanNotificationSource, <[In]()> ByVal ignoreDuplicate As Boolean, <[In]()> ByVal funcCallback As WlanNotificationCallbackDelegate, <[In]()> ByVal callbackContext As IntPtr, <[In]()> ByVal reserved As IntPtr, _
     ByRef prevNotifSource As WlanNotificationSource) As Integer
    End Function

    <DllImport("wlanapi.dll")> _
    Public Shared Function WlanScan(<[In]()> ByVal clientHandle As IntPtr, <[In](), MarshalAs(UnmanagedType.LPStruct)> ByVal interfaceGuid As Guid, <[In]()> ByVal pDot11Ssid As IntPtr, <[In]()> ByVal pIeData As IntPtr, <[In](), Out()> ByVal pReserved As IntPtr) As Integer
    End Function

    <DllImport("wlanapi.dll")> _
    Public Shared Function WlanSetInterface(<[In]()> ByVal clientHandle As IntPtr, <[In](), MarshalAs(UnmanagedType.LPStruct)> ByVal interfaceGuid As Guid, <[In]()> ByVal opCode As WlanIntfOpcode, <[In]()> ByVal dataSize As UInteger, <[In]()> ByVal pData As IntPtr, <[In](), Out()> ByVal pReserved As IntPtr) As Integer
    End Function

    <DllImport("wlanapi.dll")> _
    Public Shared Function WlanSetProfile(<[In]()> ByVal clientHandle As IntPtr, <[In](), MarshalAs(UnmanagedType.LPStruct)> ByVal interfaceGuid As Guid, <[In]()> ByVal flags As WlanProfileFlags, <[In](), MarshalAs(UnmanagedType.LPWStr)> ByVal profileXml As String, <[In](), [Optional](), MarshalAs(UnmanagedType.LPWStr)> ByVal allUserProfileSecurity As String, <[In]()> ByVal overwrite As Boolean, _
     <[In]()> ByVal pReserved As IntPtr, ByRef reasonCode As WlanReasonCode) As Integer
    End Function

#End Region

#Region "Private Methods"

    <StructLayout(LayoutKind.Sequential)> _
    Friend Structure WlanAvailableNetworkListHeader
        Public ReadOnly numberOfItems As UInteger
        Private index As UInteger
    End Structure

    <StructLayout(LayoutKind.Sequential)> _
    Friend Structure WlanBssListHeader
        Private ReadOnly totalSize As UInteger
        Friend ReadOnly numberOfItems As UInteger
    End Structure

    <StructLayout(LayoutKind.Sequential)> _
    Friend Structure WlanInterfaceInfoListHeader
        Public ReadOnly numberOfItems As UInteger
        Private ReadOnly index As UInteger
    End Structure

    <StructLayout(LayoutKind.Sequential)> _
    Friend Structure WlanProfileInfoListHeader
        Public ReadOnly numberOfItems As UInteger
        Private ReadOnly index As UInteger
    End Structure

    <StructLayout(LayoutKind.Sequential)> _
    Private Structure WlanSecurityAttributes
        <MarshalAs(UnmanagedType.Bool)> _
        Private ReadOnly securityEnabled As Boolean
        <MarshalAs(UnmanagedType.Bool)> _
        Private ReadOnly oneXEnabled As Boolean
        Private ReadOnly dot11AuthAlgorithm As Dot11AuthAlgorithm
        Private ReadOnly dot11CipherAlgorithm As Dot11CipherAlgorithm
    End Structure

#End Region
End Class

