﻿Module Module_DataArray

    ' ----------------------------------------------------------------------------------------------------------
    ' DataArrayLen length : 6 hours === 6 * 3600 * 10 Hz === 216000 samples === 2 mega bytes
    ' ----------------------------------------------------------------------------------------------------------
    Friend Const DataArrayLen As Int32 = 6 * 3600 * 10

    Friend Const TimerFrequencyHz As Int32 = 10
    Friend Const TimerIntervalMillisec As Int32 = 1000 \ TimerFrequencyHz

    Friend DataArray1 As DataArray = New DataArray(DataArrayLen)

    Friend SignalGraph1 As SignalGraph = New SignalGraph


    ' ====================================================================================================
    '  MilliTimer
    ' ====================================================================================================
    Private WithEvents mTimer As AccurateTimer = New AccurateTimer

    Friend Sub SignalReaderStart()
        mTimer.Interval = TimerIntervalMillisec
        mTimer.Start()
    End Sub

    Friend Sub SignalReaderStop()
        mTimer.Stop()
    End Sub

    Private Sub mTimer_TimerTick(ByVal TotalMillisec As Double) Handles mTimer.Tick
        Dim nd(NetworkDataArray.Length - 1) As DataArray.NetworkGraphData
        For i As Int32 = 0 To nd.Length - 1
            With nd(i)
                .SSID = NetworkDataArray(i).SSID
                .RSSI = NetworkDataArray(i).RSSI
                .Quality = NetworkDataArray(i).Quality
                .DetectionPercentual = NetworkDataArray(i).DetectionPercentual
            End With
        Next
        DataArray1.AddElement(nd)
    End Sub

End Module
